/*
 * AddActionDialog.java
 *
 * Created on October 8, 2008, 1:29 PM
 */
package org.sun.jsat;

import java.util.List;
import javax.swing.JButton;
import javax.swing.JTree;
import javax.swing.tree.TreePath;
import org.sun.jsat.trees.ResourceModelRootTreeNode;
import org.sun.jsat.trees.ActionDefTreeNode;
import org.sun.jsat.trees.RefreshableTreeNode;
import org.sun.jsat.trees.RuleDefTreeNode;
import org.sun.jsat.trees.ToolTipTree;
import securityanalyzer.resourcemodel.ActionDefinition;
import securityanalyzer.resourcemodel.ParameterDefinition;
import securityanalyzer.resourcemodel.RuleDefinition;

/**
 *
 * @author  joe
 */
public class AddDialog extends javax.swing.JFrame {

    public final static int ADDING_ACTIONS = 1;
    public final static int ADDING_RULES = 2;
    int type;
    ActionDefinition currAction;

    /** Creates new form AddActionDialog */
    public AddDialog() {
        initComponents();
        parametersPane = (ParametersPanel) parametersPanel;
    }

    public AddDialog(int type) {
        this.type = type;
        initComponents();
        parametersPane = (ParametersPanel) parametersPanel;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        setProperRootNode();
        definitionsTree = new ToolTipTree(rootNode);
        jLabel1 = new javax.swing.JLabel();
        createButton = new javax.swing.JButton();
        parametersPanel = new ParametersPanel();
        cancelButton = new javax.swing.JButton();

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 376, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 260, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        definitionsTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                definitionsTreeMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                definitionsTreeMousePressed(evt);
            }
        });
        jScrollPane1.setViewportView(definitionsTree);

        jLabel1.setText(org.openide.util.NbBundle.getMessage(AddDialog.class, "AddDialog.jLabel1.text")); // NOI18N

        createButton.setText(org.openide.util.NbBundle.getMessage(AddDialog.class, "AddDialog.createButton.text")); // NOI18N

        parametersPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        parametersPanel.setPreferredSize(new java.awt.Dimension(250, 400));

        org.jdesktop.layout.GroupLayout parametersPanelLayout = new org.jdesktop.layout.GroupLayout(parametersPanel);
        parametersPanel.setLayout(parametersPanelLayout);
        parametersPanelLayout.setHorizontalGroup(
            parametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 246, Short.MAX_VALUE)
        );
        parametersPanelLayout.setVerticalGroup(
            parametersPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 396, Short.MAX_VALUE)
        );

        cancelButton.setText(org.openide.util.NbBundle.getMessage(AddDialog.class, "AddDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 261, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(parametersPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createSequentialGroup()
                                .add(cancelButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(createButton)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(jLabel1))
                .add(159, 159, 159))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(parametersPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(createButton)
                            .add(cancelButton)))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 431, Short.MAX_VALUE))
                .add(59, 59, 59))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-590)/2, (screenSize.height-501)/2, 590, 501);
    }// </editor-fold>//GEN-END:initComponents

private void definitionsTreeMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_definitionsTreeMousePressed
}//GEN-LAST:event_definitionsTreeMousePressed

private void definitionsTreeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_definitionsTreeMouseClicked
    TreePath currPath = definitionsTree.getPathForLocation(evt.getX(), evt.getY());

    if (currPath == null) {
        return;
    }
    Object node = currPath.getLastPathComponent();

    switch (type) {
        case ADDING_ACTIONS:
            if (node instanceof ActionDefTreeNode) {
                parametersPane.clearParameterFields();

                ActionDefTreeNode actionNode = (ActionDefTreeNode) node;
                ActionDefinition ad = actionNode.getBaseObject();
                List<ParameterDefinition> pds = ad.getParameters();

                for (ParameterDefinition pd : pds) {
                    parametersPane.addParameterField(pd.getName());
                }

                parametersPane.updateUI();
            }
            break;
        case ADDING_RULES:
            if (node instanceof RuleDefTreeNode) {
                parametersPane.clearParameterFields();

                RuleDefTreeNode ruleNode = (RuleDefTreeNode) node;
                RuleDefinition rd = ruleNode.getBaseObject();
                List<ParameterDefinition> pds = rd.getParameters();

                for (ParameterDefinition pd : pds) {
                    parametersPane.addParameterField(pd.getName());
                }

                parametersPane.updateUI();
            }
            break;
        default:
            return;
    }
}//GEN-LAST:event_definitionsTreeMouseClicked

private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
this.dispose();
}//GEN-LAST:event_cancelButtonActionPerformed

    private RefreshableTreeNode rootNode;
    
    private void setProperRootNode() {
        switch(type) {
            case ADDING_RULES:
                 rootNode = new ResourceModelRootTreeNode(ResourceModelRootTreeNode.DISPLAY_RULES);
                 break;
            case ADDING_ACTIONS:
                 rootNode = new ResourceModelRootTreeNode(ResourceModelRootTreeNode.DISPLAY_RESOURCES);
                 break;
            default:
                 rootNode = new RefreshableTreeNode(null, "undefined");
                 break;
        }
        rootNode.refresh();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new  

              Runnable() {
                 public void run() {
                new AddDialog().setVisible(true);
            }
        });
    }

    public int getType() {
        return type;
    }
    
    public JButton getCreateButton() {
        return createButton;
    }

    public JTree getDefinitionsTree() {
        return definitionsTree;
    }

    public ParametersPanel getParametersPanel() {
        return parametersPane;
    }

    public ActionDefinition getCurrentlySelectedDefinition() {
        return currAction;
    }
    private ParametersPanel parametersPane;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton createButton;
    private javax.swing.JTree definitionsTree;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel parametersPanel;
    // End of variables declaration//GEN-END:variables
}
