/*
 * ImportDialog.java
 *
 * Created on October 10, 2008, 1:56 PM
 */
package org.sun.jsat;

import java.io.File;
import java.util.List;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author  joe
 */
public class ImportDialog extends javax.swing.JDialog {

    File currentImportFile;
    String currentConfigurationName;
    public final static String CURRENT_CONFIGURATION = "Current configuration";

    /** Creates new form ImportDialog */
    public ImportDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        
        
        
        currentConfigurationName = "";
        
        initComponents();
    }
    
    public ImportDialog(java.awt.Frame parent, boolean modal, List<String> configurations) {
        super(parent, modal);
        
        currentConfigurationName = "";
        
        initComponents();
        
        configurations.add(0, "New...");
        
        importDestinationBox.setModel(new DefaultComboBoxModel(configurations.toArray(new String[0])));
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        fileNameTextField = new javax.swing.JTextField();
        browseButton = new javax.swing.JButton();
        importDestinationBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.title")); // NOI18N

        fileNameTextField.setText(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.fileNameTextField.text")); // NOI18N
        fileNameTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                fileNameTextFieldKeyTyped(evt);
            }
        });

        browseButton.setText(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.browseButton.text")); // NOI18N
        browseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtonActionPerformed(evt);
            }
        });

        importDestinationBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Current configuration", "New..." }));
        importDestinationBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importDestinationBoxActionPerformed(evt);
            }
        });

        jLabel1.setText(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.jLabel1.text")); // NOI18N

        jLabel2.setText(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.jLabel2.text")); // NOI18N

        okButton.setText(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.okButton.text")); // NOI18N

        cancelButton.setText(org.openide.util.NbBundle.getMessage(ImportDialog.class, "ImportDialog.cancelButton.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(jLabel1)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 230, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(fileNameTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 223, Short.MAX_VALUE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(browseButton)))
                        .add(30, 30, 30))
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .addContainerGap(286, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(cancelButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(okButton)
                        .addContainerGap())
                    .add(layout.createSequentialGroup()
                        .add(importDestinationBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(185, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(50, 50, 50)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(browseButton)
                    .add(fileNameTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(importDestinationBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 54, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(okButton)
                    .add(cancelButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void browseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtonActionPerformed
    JFileChooser jfc = new JFileChooser();

    int ret = jfc.showOpenDialog(this);
    
    if (ret == JFileChooser.APPROVE_OPTION) {
        currentImportFile = jfc.getSelectedFile();
    }
    
    fileNameTextField.setText(currentImportFile.getAbsolutePath());

}//GEN-LAST:event_browseButtonActionPerformed

private void fileNameTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_fileNameTextFieldKeyTyped

    File f = new File(fileNameTextField.getText());
    
    if (f.exists()) {
        currentImportFile = f;
    }
    
}//GEN-LAST:event_fileNameTextFieldKeyTyped

private void importDestinationBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importDestinationBoxActionPerformed
    Object o = importDestinationBox.getModel().getSelectedItem();
    
    if (!(o instanceof String)) {
        return;
    }
    
    String s = (String) o;
    
    if (s.equals("New...")) {
        
        String ret = JOptionPane.showInputDialog(this, "Name of configuration");

        ComboBoxModel cbm = importDestinationBox.getModel();
        DefaultComboBoxModel dcbm = (DefaultComboBoxModel) cbm;

        dcbm.addElement(ret);
        dcbm.setSelectedItem(ret);
    }
    
}//GEN-LAST:event_importDestinationBoxActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                ImportDialog dialog = new ImportDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    public JButton getCancelButton() {
        return cancelButton;
    }

    public JButton getOkButton() {
        return okButton;
    }
    
    public File getImportFile() {
        return currentImportFile;
    }
    
    public String getConfigurationSelection() {
        return (String) importDestinationBox.getModel().getSelectedItem();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browseButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextField fileNameTextField;
    private javax.swing.JComboBox importDestinationBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
}
