/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sun.jsat;

import java.io.Serializable;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
import org.openide.util.Utilities;
import org.sun.jsat.trees.CodeGroupingRootTreeNode;
import org.sun.jsat.trees.RefreshableTreeNode;
import org.sun.jsat.trees.ToolTipTree;
import securityanalyzer.useframework.CodeGrouping;

/**
 * Top component which displays something.
 */
final class SecurityToolTopComponent extends TopComponent {

    private static SecurityToolTopComponent instance;

    public JButton getDiffButton() {
        return diffButton;
    }

    public JButton getStaticAnalysisButton() {
        return staticAnalysisButton;
    }

    public JButton getAddRuleButton() {
        return addRuleButton;
    }
    
    public JButton getAddActionButton() {
        return addActionButton;
    }

    public JButton getRemoveRuleButton() {
        return removeRuleButton;
    }

    public JTree getActionTree() {
        return actionTree;
    }

    public JTree getRuleTree() {
        return ruleTree;
    }

    public JButton getRemoveActionButton() {
        return removeActionButton;
    }
    
    public JButton getImportButton() {
        return importButton;
    }
    
    public JButton getExportButton() {
        return exportButton;
    }
    
    public JComboBox getFilterSelectionComboBox() {
        return filterSelectionComboBox;
    }
    /** path to the icon used by the component and its open action */
    static final String ICON_PATH = "org/sun/jsat/bricks.png";
    private static final String PREFERRED_ID = "SecurityToolTopComponent";
    private CodeGrouping cg = null;

    private SecurityToolTopComponent() {
        initComponents();
        
        actionsRootTreeNode.add(actionsTreeNode);
        rulesRootTreeNode.add(rulesTreeNode);
        
        setName(NbBundle.getMessage(SecurityToolTopComponent.class, "CTL_SecurityToolTopComponent"));
        setToolTipText(NbBundle.getMessage(SecurityToolTopComponent.class, "HINT_SecurityToolTopComponent"));
        setIcon(Utilities.loadImage(ICON_PATH, true));

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        jToolBar1 = new javax.swing.JToolBar();
        importButton = new javax.swing.JButton();
        exportButton = new javax.swing.JButton();
        staticAnalysisButton = new javax.swing.JButton();
        diffButton = new javax.swing.JButton();
        filterSelectionComboBox = new javax.swing.JComboBox();
        actionPanel = new javax.swing.JPanel();
        actionScrollPane = new javax.swing.JScrollPane();
        actionTree = new ToolTipTree(actionsRootTreeNode);
        addActionButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        removeActionButton = new javax.swing.JButton();
        rulePanel = new javax.swing.JPanel();
        ruleScrollPane = new javax.swing.JScrollPane();
        ruleTree = new ToolTipTree(rulesRootTreeNode);
        addRuleButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        removeRuleButton = new javax.swing.JButton();

        jToolBar1.setRollover(true);

        org.openide.awt.Mnemonics.setLocalizedText(importButton, "Import...");
        jToolBar1.add(importButton);

        org.openide.awt.Mnemonics.setLocalizedText(exportButton, "Export...");
        jToolBar1.add(exportButton);

        org.openide.awt.Mnemonics.setLocalizedText(staticAnalysisButton, "Static Analysis...");
        jToolBar1.add(staticAnalysisButton);

        org.openide.awt.Mnemonics.setLocalizedText(diffButton, "Diff...");
        diffButton.setFocusable(false);
        diffButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        diffButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(diffButton);

        filterSelectionComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jToolBar1.add(filterSelectionComboBox);

        actionPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        actionTree.setRootVisible(false);
        actionScrollPane.setViewportView(actionTree);
        actionTree.setRootVisible(false);

        org.openide.awt.Mnemonics.setLocalizedText(addActionButton, "Add Action...");

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, "Actions:");

        org.openide.awt.Mnemonics.setLocalizedText(removeActionButton, "Remove Action");

        org.jdesktop.layout.GroupLayout actionPanelLayout = new org.jdesktop.layout.GroupLayout(actionPanel);
        actionPanel.setLayout(actionPanelLayout);
        actionPanelLayout.setHorizontalGroup(
            actionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(actionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(actionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(actionPanelLayout.createSequentialGroup()
                        .add(addActionButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(removeActionButton))
                    .add(jLabel1)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, actionScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE))
                .addContainerGap())
        );
        actionPanelLayout.setVerticalGroup(
            actionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(actionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(actionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addActionButton)
                    .add(removeActionButton))
                .add(18, 18, 18)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(actionScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 308, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(106, Short.MAX_VALUE))
        );

        rulePanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        ruleTree.setRootVisible(false);
        ruleScrollPane.setViewportView(ruleTree);
        ruleTree.setRootVisible(false);

        org.openide.awt.Mnemonics.setLocalizedText(addRuleButton, "Add Rule...");

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, "Rules:");

        org.openide.awt.Mnemonics.setLocalizedText(removeRuleButton, "Remove Rule");

        org.jdesktop.layout.GroupLayout rulePanelLayout = new org.jdesktop.layout.GroupLayout(rulePanel);
        rulePanel.setLayout(rulePanelLayout);
        rulePanelLayout.setHorizontalGroup(
            rulePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(rulePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(rulePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(rulePanelLayout.createSequentialGroup()
                        .add(addRuleButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(removeRuleButton))
                    .add(jLabel2)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, ruleScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE))
                .addContainerGap())
        );
        rulePanelLayout.setVerticalGroup(
            rulePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(rulePanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(rulePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(addRuleButton)
                    .add(removeRuleButton))
                .add(18, 18, 18)
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(ruleScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 308, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(106, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 479, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(569, Short.MAX_VALUE))
            .add(layout.createSequentialGroup()
                .add(20, 20, 20)
                .add(actionPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 35, Short.MAX_VALUE)
                .add(rulePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(252, 252, 252))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(31, 31, 31)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(actionPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(rulePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(69, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    private RefreshableTreeNode rulesRootTreeNode = new RefreshableTreeNode(null, "");
    private RefreshableTreeNode actionsRootTreeNode = new RefreshableTreeNode(null, "");
    private CodeGroupingRootTreeNode rulesTreeNode = new CodeGroupingRootTreeNode(null, CodeGroupingRootTreeNode.DISPLAY_RULES);
    private CodeGroupingRootTreeNode actionsTreeNode = new CodeGroupingRootTreeNode(null, CodeGroupingRootTreeNode.DISPLAY_ACTIONS);
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel actionPanel;
    private javax.swing.JScrollPane actionScrollPane;
    private javax.swing.JTree actionTree;
    private javax.swing.JButton addActionButton;
    private javax.swing.JButton addRuleButton;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.JButton diffButton;
    private javax.swing.JButton exportButton;
    private javax.swing.JComboBox filterSelectionComboBox;
    private javax.swing.JButton importButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JButton removeActionButton;
    private javax.swing.JButton removeRuleButton;
    private javax.swing.JPanel rulePanel;
    private javax.swing.JScrollPane ruleScrollPane;
    private javax.swing.JTree ruleTree;
    private javax.swing.JButton staticAnalysisButton;
    // End of variables declaration//GEN-END:variables

    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link findInstance}.
     */
    public static synchronized SecurityToolTopComponent getDefault() {
        if (instance == null) {
            instance = new SecurityToolTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the SecurityToolTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized SecurityToolTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(SecurityToolTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof SecurityToolTopComponent) {
            return (SecurityToolTopComponent) win;
        }
        Logger.getLogger(SecurityToolTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID +
                "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }
    
    public void setRootActionNode(CodeGroupingRootTreeNode rootNode) {
        actionsTreeNode.removeFromParent();
        actionsTreeNode = rootNode;
        actionsRootTreeNode.add(rootNode);
        actionsRootTreeNode.refresh();
    }
    
    public void setRootRuleNode(CodeGroupingRootTreeNode rootNode) {
        rulesTreeNode.removeFromParent();
        rulesTreeNode = rootNode;
        rulesRootTreeNode.add(rootNode);
        rulesRootTreeNode.refresh();
    }

    public void setCodeGrouping(CodeGrouping cg) {
        this.cg = cg;
        actionsTreeNode.setCg(cg);
        rulesTreeNode.setCg(cg);
        refreshTrees();
    }
    
    public void refreshTrees() {
        refreshTree(actionTree, actionsTreeNode);
        refreshTree(ruleTree, rulesTreeNode);
    }

    private void refreshTree(JTree tree, CodeGroupingRootTreeNode rootNode) {
        if (tree != null && rootNode != null) {
            if (rootNode.getCg() == null && cg != null) {
                rootNode.setCg(cg);
            }
            rootNode.refresh();
            SwingUtilities.updateComponentTreeUI(tree);
        }
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    @Override
    public void componentOpened() {
        new JSATMain().init();
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
    }

    /** replaces this in object stream */
    @Override
    public Object writeReplace() {
        return new ResolvableHelper();
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    final static class ResolvableHelper implements Serializable {

        private static final long serialVersionUID = 1L;

        public Object readResolve() {
            return SecurityToolTopComponent.getDefault();
        }
    }
}
