/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.sun.jsat.controllers;

import org.sun.jsat.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JComboBox;
import org.sun.jsat.trees.CodeGroupingRootTreeNode;
import securityanalyzer.useframework.RulesActionsContainer;

/**
 *
 * @author joe
 */
public class FilterChangedController implements ActionListener {
    
    JSATMain main;
    JComboBox filterBox;
    
    public FilterChangedController(JSATMain main, JComboBox filterBox) {
        this.main = main;
        this.filterBox = filterBox;
    }
    
    /**
     * Called when something new is selected in the filter box
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
        
        //We'll always use just string arrays for this model
        String s = (String)filterBox.getModel().getSelectedItem();
        
        int policyType = CodeGroupingRootTreeNode.POLICY_TYPE_ANALYSIS;
        RulesActionsContainer rac = main.getSecurityModel().getDefaultCodeGroup().getAnalysisPolicyByName(s);
        
        if(rac == null) {
            policyType = CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL;
            rac = main.getSecurityModel().getDefaultCodeGroup().getExternalPolicyByName(s);
        }
        
        CodeGroupingRootTreeNode newBaseActionsNode;
        CodeGroupingRootTreeNode newBaseRulesNode;
        

//        if(rac != null) {
            newBaseActionsNode = main.getRootNodes().getOrCreateActionNode(s, policyType);
            newBaseRulesNode = main.getRootNodes().getOrCreateRuleNode(s, policyType);
//            newBaseActionsNode = new CodeGroupingRootTreeNode(
//                    main.getSecurityModel().getDefaultCodeGroup(), 
//                    CodeGroupingRootTreeNode.DISPLAY_ACTIONS, 
//                    policyType, s);
//
//            newBaseRulesNode = new CodeGroupingRootTreeNode(
//                    main.getSecurityModel().getDefaultCodeGroup(),
//                    CodeGroupingRootTreeNode.DISPLAY_RULES,
//                    policyType, s);
//        }
//        
//        else {
//            if(s.equals(ImportDialog.CURRENT_CONFIGURATION)) {
//                policyType = CodeGroupingRootTreeNode.POLICY_TYPE_DEFAULT;
//                newBaseActionsNode = new CodeGroupingRootTreeNode(main.getSecurityModel().getDefaultCodeGroup(),
//                        CodeGroupingRootTreeNode.DISPLAY_ACTIONS);
//                newBaseRulesNode = new CodeGroupingRootTreeNode(main.getSecurityModel().getDefaultCodeGroup(),
//                        CodeGroupingRootTreeNode.DISPLAY_RULES);
//            }
//            else {
//                return;
//            }
//        }
//        
        newBaseActionsNode.setName(s);
        newBaseRulesNode.setName(s);
        
        main.setCurrentPolicyName(s);
        
        main.changeTreeRoots(newBaseActionsNode, newBaseRulesNode);
        
    }
    

}
