/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sun.jsat.controllers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.DefaultComboBoxModel;
import org.sun.jsat.ExportDialog;
import org.sun.jsat.JSATMain;
import securityanalyzer.useframework.PolicyConfigurationWriter;
import securityanalyzer.useframework.RulesActionsContainer;

/**
 *
 * @author joe
 */
public class InitializeExportController implements ActionListener {

    JSATMain main;

    public InitializeExportController(JSATMain main) {
        this.main = main;
    }

    public void actionPerformed(ActionEvent e) {

        ExportDialog ed = new ExportDialog(null, false);
        ExportController ec = new ExportController(main, ed);
        ed.getOkButton().addActionListener(ec);
        
        String[] policies = main.getAllPolicyNames();
        
        ed.getSourcePolicyBox().setModel(new DefaultComboBoxModel(policies));
        
        ed.getSourcePolicyBox().getModel().setSelectedItem(main.getCurrentPolicyName());

        ed.setVisible(true);

    }
}

class ExportController implements ActionListener {

    JSATMain main;
    ExportDialog ed;

    public ExportController(JSATMain main, ExportDialog ed) {
        this.main = main;
        this.ed = ed;
    }

    public void actionPerformed(ActionEvent e) {

        File f = ed.getExportFile();
        
        if(f == null) {
            return;
        }
        
        String s = (String)ed.getSourcePolicyBox().getModel().getSelectedItem();
        
        RulesActionsContainer rac = main.getSecurityModel().getDefaultCodeGroup().getAnalysisPolicyByName(s);
        
        if(rac == null) {
            rac = main.getSecurityModel().getDefaultCodeGroup().getExternalPolicyByName(s);
        }

        ed.dispose();

        //TODO: Create a specific kind of writer and use the policy exporter interface
        PolicyConfigurationWriter pcw = new PolicyConfigurationWriter(f);

        pcw.exportPolicy(rac);
        main.refreshWindow();
    }
}
