/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.sun.jsat.controllers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import org.sun.jsat.ImportDialog;
import org.sun.jsat.JSATMain;
import securityanalyzer.useframework.PolicyConfigurationReader;
import securityanalyzer.useframework.RulesActionsContainer;


/**
 *
 * @author joe
 */
public class InitializeImportController implements ActionListener {
    
    JSATMain main;
    
    public InitializeImportController(JSATMain main) {
        this.main = main;
    }
    
    public void actionPerformed(ActionEvent e) {
        
        // Build the list of configuration names to choose from
        Collection<String> analysisNames = main.getSecurityModel().getDefaultCodeGroup().getAllAnalysisPolicyNames();
        Collection<String> externalNames = main.getSecurityModel().getDefaultCodeGroup().getAllExternalPolicyNames();
        
        List<String> allNames = new ArrayList<String>();
        
        for(String s: analysisNames) {
            allNames.add(s);
        }
        
        for(String s: externalNames) {
            allNames.add(s);
        }        
        
        // Create the dialog and hook it up
        ImportDialog id = new ImportDialog(null, false, allNames);
        ImportController ic = new ImportController(main, id);
        
        id.getOkButton().addActionListener(ic);
        id.getCancelButton().addActionListener(ic);
        
        id.setVisible(true);
    }

}

class ImportController implements ActionListener {
    
    JSATMain main;
    ImportDialog id;
    
    public ImportController(JSATMain main, ImportDialog id) {
        this.main = main;
        this.id = id;
    }
    
    public void actionPerformed(ActionEvent e) {
        
        if(e.getSource().equals(id.getCancelButton())) {
            id.dispose();
            return;
        }
        
        //Otherwise, they clicked okay
        
        File f = id.getImportFile();
        
        if(f == null) {
            return;
        }
        
        String policy = id.getConfigurationSelection();
        
        if(policy == null) {
            return;
        }
        
        if(policy.equals("New...")) {
            return;
        }
        
        id.dispose();
        
        RulesActionsContainer rac;

        rac = new RulesActionsContainer();
        main.getSecurityModel().getDefaultCodeGroup().addExternalPolicy(policy, rac);

        PolicyConfigurationReader pcr = new PolicyConfigurationReader(f);
        
        pcr.importPolicy(rac);
        main.refreshWindow();
        main.setCurrentPolicyName(policy);
        main.refreshFilterList();
        
    }
    
}
