package org.sun.jsat.trees;

import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;
import securityanalyzer.resourcemodel.ActionDefinition;
import securityanalyzer.resourcemodel.ParameterDefinition;

/**
 *
 * 
 */
public class ActionDefTreeNode extends RefreshableTreeNode<ActionDefinition> {
    
    public ActionDefTreeNode(ActionDefinition ad) {
        super(ad, ad.getName());
        this.baseObject = ad;
    }

    @Override
    public void generateMissingChildren() {
        synchronized (updateMutex){
            generationActions();
            for (ParameterDefinition pd : baseObject.getParameters()){
                if (childrenMap.get(pd) == null){
                    ParameterDefTreeNode pdtn = new ParameterDefTreeNode(pd);
                    childrenMap.put(pd, pdtn);
                    this.add(pdtn);
                }
            }
        }
    }

    @Override
    public void removeExtraChildren() {
        synchronized (updateMutex){
            generationActions();
            List<ParameterDefinition> pds = new ArrayList<ParameterDefinition>();
            for (Entry<Object, RefreshableTreeNode> e : childrenMap.entrySet()){
                if (e.getKey() instanceof ParameterDefinition){
                    ParameterDefinition p = (ParameterDefinition)e.getKey();
                    if (!baseObject.getParameters().contains(p)){
                        pds.add(p);
                        this.remove(e.getValue());
                    }
                }
            }
            for(ParameterDefinition pd: pds) {
                childrenMap.remove(pd);
            }
        }
    }
}
