package org.sun.jsat.trees;

import java.awt.Color;
import java.awt.Component;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

public class HighlightingTreeCellRenderer extends DefaultTreeCellRenderer {
    private Object value;
    private Color highlightOffset;

    public HighlightingTreeCellRenderer() {
        super();
        setHighlightColorOffset(255, 0, 0);
    }
    
    public HighlightingTreeCellRenderer(int r, int g, int b) {
        super();
        setHighlightColorOffset(r, g, b);
    }

    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        this.value = value;
        Component ret = super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
        this.value = null;
        return ret;
    }
    
    @Override
    public void setForeground(Color bg) {
        if (this.value instanceof RefreshableTreeNode) {
            RefreshableTreeNode<?> rtn = (RefreshableTreeNode<?>) this.value;
            if (rtn.isHighlighted()) {
                bg = highlightColor(bg);
            }
        }
        super.setForeground(bg);
    }
    
    /*@Override
    public Color getBackgroundSelectionColor(){
    Color bg = super.getBackgroundSelectionColor();
    if (this.value instanceof RefreshableTreeNode) {
    RefreshableTreeNode<?> rtn = (RefreshableTreeNode<?>) this.value;
    if (rtn.isHighlighted()) {
    bg = highlightColor(bg);
    }
    }
    return bg;
    }
    
    @Override
    public Color getBackgroundNonSelectionColor() {
    Color bg = super.getBackgroundNonSelectionColor();
    if (this.value instanceof RefreshableTreeNode) {
    RefreshableTreeNode<?> rtn = (RefreshableTreeNode<?>) this.value;
    if (rtn.isHighlighted()) {
    bg = highlightColor(bg);
    }
    }
    return bg;
    }*/
    
    
    
    public Color highlightColor(Color c){
        return new Color(Math.min(c.getRed() + highlightOffset.getRed(), 255), 
                Math.min(c.getGreen() + highlightOffset.getGreen(), 255), 
                Math.min(c.getBlue() + highlightOffset.getBlue(), 255));
    }
    
    public Color getHighlightColorOffest(){
        return highlightOffset;
    }
    
    public void setHighlightColorOffset(int r, int g, int b){
        highlightOffset = new Color(r,g,b);
    }
}
