package org.sun.jsat.trees;

import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;
import securityanalyzer.resourcemodel.ResourceDefinition;
import securityanalyzer.resourcemodel.ActionDefinition;

/**
 *
 * 
 */
public class ResourceDefTreeNode extends RefreshableTreeNode<ResourceDefinition> {
    
    public ResourceDefTreeNode(ResourceDefinition rd) {
        super(rd, rd.getName());
        this.baseObject = rd;
    }
    
    @Override
    public void generateMissingChildren() {
        synchronized (updateMutex){
            generationActions();
            for (ActionDefinition ad : baseObject.getActions()){
                if (childrenMap.get(ad) == null){
                    ActionDefTreeNode adtn = new ActionDefTreeNode(ad);
                    this.add(adtn);
                    childrenMap.put(ad, adtn);
                }
            }
            sortChildren();
        }
    }
    
    @Override
    public void removeExtraChildren() {
        synchronized (updateMutex){
            generationActions();
            List<ActionDefinition> ads = new ArrayList<ActionDefinition>();
            for (Entry<Object, RefreshableTreeNode> e : childrenMap.entrySet()){
                if (e.getKey() instanceof ActionDefinition){
                    ActionDefinition a = (ActionDefinition)e.getKey();
                    if (!baseObject.getActions().contains(a)){
                        ads.add(a);
                        this.remove(e.getValue());
                    }
                }
            }
            for(ActionDefinition ad: ads) {
                childrenMap.remove(ad);
            }
        }
    }
}
