package securityanalyzer.resourcemodel;

import java.io.File;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import org.junit.Test;

import securityanalyzer.resourcemodel.reader.ResourceModelReader;

public class AppliedRuleResolverTest {

	@Test
	public void testResolve() {

		ResourceModelReader.setResourcesAndPermissions(new File(
				"Resource Model/secondDraft.xml"));

		ResourceDefinition rd = ResourceModel
				.getResourceByName("Socket Connections");

		ActionDefinition ad = rd.getActionByName("SocketConnect");

		FilledActionDefinition fad = new FilledActionDefinition(ad);

		List<ParameterDefinition> pds = ad.getParameters();

		fad.setMapping(pds.get(0), "*.sun.com");
		fad.setMapping(pds.get(1), "8000:");

		Set<FilledRuleDefinition> frds = VariableResolution
				.getFilledRulesFrom(fad, "Permission");

		for (FilledRuleDefinition frd : frds) {
			for (Entry<ParameterDefinition, String> e : frd
					.getAllDefinedMappings().entrySet()) {
				System.out.println(e.getKey().getName() + ": " + e.getValue());
			}
		}
	}

	@Test
	public void testReverse() {
		Map<String, String> result = VariableResolution
				.getActionParametersFromRuleParameter(
						"{path}", "/tmp/abc/-");
		Map<String, String> result2 = VariableResolution
				.getActionParametersFromRuleParameter(
						"{localhost}:[{portrange}]", "*.sun.com:[8000:8200]");
		Map<String, String> result3 = VariableResolution
				.getActionParametersFromRuleParameter("getenv.{varName}",
						"getenv.a.b.*");
		Map<String, String> result4 = VariableResolution
		.getActionParametersFromRuleParameter("loadLibrary.{libraryName}",
				"loadLibrary.a.b.*");

		System.out.println(result);
		System.out.println(result2);
		System.out.println(result3);
		System.out.println(result4);
		
		return;
	}

}
